unit pcl;

interface
uses Inferno, X, XLib, VGAColors, Alf, Ini;

const
  PrintResX	= 300;	//    ,   
  PrintResY	= 300;	// (      )
  PrintRes	= '300';//    

procedure PrintWnd(const dr: TDrawable; const xl, yl: LongInt; var fl: Text);
procedure pclview(const name: String);

implementation
const
  WndMaxX	= 700;	//       
  WndMaxY	= 500;
  skx		= 10;	//      ()
  sky		= 10;
  smx		= 100;	//      ()
  smy		= 100;
  BorderX	= 10;
  BorderY	= 10;
  FontName	: AnsiString = '*';

procedure PrintWnd(const dr: TDrawable; const xl, yl: LongInt; var fl: Text);
var
  img		: PXImage;
  byteperline, 
  x, y, b, o	: LongInt;
  d		: Byte;

begin
  write(fl, '&k0G');			// cr=cr, lf=lf, ff=ff
  write(fl, '&l8C');			//   
  write(fl, '&s0C');			// nowrap Lines
  write(fl, '*p+0Y');			//  
  write(fl, '*p0X');
  write(fl, '*t', PrintRes, 'R');	// 
  write(fl, '*b0M');			//  
  write(fl, '*r1A');			//     

  img := XGetImage(prDisplay, dr, 0, 0, xl, yl, $ffffffff, ZPixMap);

  for y := 1 to yl do begin
    byteperline := (xl+7) div 8;
    write(fl, '*b', byteperline, 'W');		//   xx   
    x := 0;
    for b := 1 to byteperline do begin
      d := 0;
      for o := 0 to 7 do begin
	d := d shl 1;
        if img^.f.get_pixel(img, x, y-1) <> 0 then d := d or 1;
        inc(x);
      end;
      write(fl, chr(d));
    end;
  end;

  img^.f.destroy_image(img);

//  write(fl,'*rB');		//  
  write(fl, '*rbC');		//  
end;


procedure pclview(const name: String);
const
  wx	: LongInt = 700;
  wy	: LongInt = 400;

var
  Wnd	: TWindow;
  GC	: TGC;
  pm	: TPixMap;
  mx, y	: LongInt;
  Col	: TColors;

function Load: Boolean;
label 1;

type
  tc		= (cycAnalys, cycDraw);

var
  x, s, c, b	: LongInt;
  p, m		: PChar;
  cyc		: tc;
  str		: String[6];
  f		: File;
  t		: Byte;

  procedure Search;
  begin inc(m, 2); While (((m-2)^ <> '1') or ((m-1)^ <> 'A')) and (m-p < s) do inc(m) end;

begin
  Load := False;
  Assign(f, name); Reset(f, 1); s:=FileSize(f);
  GetMem(p, s); BlockRead(f, p^, s); Close(f);

  mx := 0;
  for cyc:=Low(tc) to High(tc) do begin

    y:=0;
    m:=p;
    Search;
    repeat
      inc(m, 3);
      if m-p >= s then Break;
      if (m-3)^ <> #27 then addlog(': ESC ');
      if (m-2)^ <> '*' then addlog(': * ');
      case (m-1)^ of
      'r': begin
        if (m^ <> 'b') or ((m+1)^ <> 'C') then addlog('   ');
        inc(m, 2);
        Search;
      end;
      'b': begin
        str:='';
        repeat
          str := str + m^; inc(m);
        until m^ = 'W';
        inc(m);
        val(str, c);
        case cyc of
          cycAnalys: begin
	    if c > mx then mx := c;
	    inc(m, c);
	  end;
          cycDraw: begin
	    for x:=1 to c do begin
	      t := ord(m^);
	      for b:=0 to 7 do begin
	        if t > 127 then XDrawPoint(prDisplay, pm, GC, (x-1)*8 + b, y);
		t:=(t and $7f) shl 1;
	      end;
	      inc(m);
	    end;
          end;
        end; 
	inc(y);
      end;
      else
        addlog('    ');
      end;
    until False;

    if cyc = cycAnalys then begin
      if (x = 0) or (y = 0) then GoTo 1;
      pm := XCreatePixMap(prDisplay, Wnd, mx * 8, y, ColorDepth);
//      XSetBackGround(prDisplay, GC, XBlackPixel(prDisplay, nScreenNum));
//      XSetForeGround(prDisplay, GC, XWhitePixel(prDisplay, nScreenNum));
      XSetForeGround(prDisplay, GC, Col[ 0]);
      XFillRectangle(prDisplay, pm, GC, 0, 0, mx * 8, y);
      XSetForeGround(prDisplay, GC, Col[14]);
      XDrawRectangle(prDisplay, pm, GC, 0, 0, mx * 8 - 1, y - 1);
      XSetForeGround(prDisplay, GC, Col[15]);
    end;

  end;
  Load := True;
  1:
  FreeMem(p, s);
end;

procedure View;
const
  tx	: LongInt = 0;
  ty	: LongInt = 0;

var
  Event	: TXEvent;

  Procedure Draw;
  var s: String;
  begin
    s:='99 x 99 %    ';
    snprintf(@(s[1]), 255, '%.0f x %.0f %%  ', [(tx / mx / 8) * 100, (ty / y) * 100]);
    XCopyArea(prDisplay, pm, Wnd, GC, tx, ty, mx * 8, y, 0, 0);
    XSetBackGround(prDisplay, GC, Col[ 7]);
    XSetForeGround(prDisplay, GC, Col[14]);
    AlfSetFont(GC, FontName);
    AlfOutTextXY(Wnd, GC, 10, 10, s);
  end;

begin
  repeat
    FlTmWithPause(Event, True);
    case Event.EventType of
      ConfigureNotify: with Event.XConfigure do if Window = Wnd then begin
        wx := Width; wy := Height;
      end;
      Expose: if Event.XExpose.Count = 0 then Draw;
      DeleteNotify: Exit;
      ButtonPress: with Event.XButton do if Window = Wnd then begin
        if x < BorderX then if tx >= smx then dec(tx, smx) else tx := 0;
        if x > wx - BorderX then inc(tx, smx);
        if y < BorderY then if ty >= smy then dec(ty, smy) else ty := 0;
        if y > wy - BorderY then inc(ty, smy);
	Draw;
      end;
      KeyPress: begin
        case KeyInResult of
	  XK_Up		: if ty >= sky then dec(ty, sky) else ty := 0;
	  XK_Down	: inc(ty, sky);
	  XK_Left	: if tx >= skx then dec(tx, skx) else tx := 0;
          XK_Right	: inc(tx, skx);

	  XK_Page_Up	: if ty >= wy then dec(ty, wy) else ty := 0;
	  XK_Page_Down	: inc(ty, wy);
	  XK_Insert,
	  XK_Delete	: if tx >= wx then dec(tx, wx) else tx := 0;
	  XK_Home,
          XK_End	: inc(tx, wx);

	  XK_Return,
	  XK_Escape	: Exit;
	  ord(' ')	: begin
	    if mx * 8 > WndMaxX then wx := WndMaxX else wx := mx * 8;
	    if y > WndMaxY then wy := WndMaxY else wy := y;
	    XResizeWindow(prDisplay, Wnd, wx, wy);
	  end;
	end;
	Draw;
      end;
    end;
  until False;
end;

begin
  NewRootWindow(10, 10, wx, wy, 20, 20, ' PCL- "' + name + '"', ' PCL- "' + name + '"', Wnd);
  GC := XCreateGC(prDisplay, Wnd, 0, NIL);
  SetVGAPalette(Wnd, Col);
//  XSetWindowBackground(prDisplay, Wnd, Col[8]);
  if Load then begin View; XFreePixMap(prDisplay, pm); end else MessageBox('    "' + name + '"');
  XFreeGC(prDisplay, GC);
  XDestroyWindow(prDisplay, Wnd);
  KeyInResult := 0;
end;


begin
  IniOpen('PCL');
  IniGet('FontName', FontName);
  IniClose;
end.
