uses Inferno, X, XLib, Mikky, Alf, VGAColors, pcl, Encoding, Dialogs, Ini;

const
  NoElement	= 65535;
  UnDefine	= -1;

  //  
  MaxPinD	= 40;		//      ( : * - 20) [      !!!]
  MaxDet	= 200;		//   
  MaxLines	= 999;		//   
  MaxPin	= 1200;		//    ()

  //    
  PixPerMMX	: Single = 10;
  PixPerMMY	: Single = 10;
  MaxStepGrid	= 2.50;		//    
  StepGrid	: Single = 1.25;
  PrintMode	: Boolean = False;
  VisualF	: Boolean = True;
  VisualS	: Boolean = True;
  DetFill	: Boolean = False;
  PrecesSearch	= 0.7;
  StepXMove	= 2.5;
  StepYMove	= 2.5;
  SelectPin	: LongInt = 0;
  LastNote	: String = '-';
  LastNoteMax	= 3;
  DetDrawOnly	: Boolean = False;
  GridEnable	: Boolean = True;
  ClearEnable	: Boolean = True; //      XClearWindow

  //  
  TopDet	: LongInt = 0;
  SelectDet	: LongInt = NoElement;

  // 
  //	  ()
  wdWayN	= 1;	//  
  wdWayP	= 6;	//   
  wdWayF	= 1;	//   :  
  wdWayS	= 2;	//  

  //	 ()
  dmPinR	= 1.00;	//  
  dmPinRk	= 1.30; //    
  dmPinB	= 0.85; //  
  dmPinBk	= 1.10; //   
  dmPinH	= 0.20; //   
  dmPinS	= 0.20; //   
  dmPinF	= 0.80; //   
  dmPinFk	= 1.10; //    
  dmPinA	= 0.10; //        
  dmSel		= 0.90; //   
  dmRamDet	= 0.20; //       
  dmFill	= 0.80; //   

  //  
  lnNo		= 0;
  lnSideF	= 2;
  lnSideS	= 4;
  lnIsol	= 8;

  //  
  pnNo		= 0;
  pnBoth	= 1;
  pnSideF	= 2;
  pnBoth1	= 3;
  pnSideS	= 4;
  pnBothB	= 5; // 
  pnBothB1	= 6;
  pnFillF	= 7; // 
  pnFillS	= 8;

  // 
  ColorF	= 10; //  
  ColorS	= 11; //  
  ColorU	=  7; //  
  ColorEr	= 12; //   (:   F   S    F  S)
  ColorG	=  8; // 
  ColorD	=  7; //  
  ColorDS	= 14; //   
  ColorS1	= 12; //  
  ColorSG	= 14; //   
  ColorB	= 15; //  
  ColorFl	=  8; // 
  ColorH	=  3; //  

  // 
  fontNote	: String = '-*-courier-medium-r-normal-*-17-*-*-*-*-*-koi8-*';	// 
  fontDets	: String = '-*-times-medium-r-normal-*-14-*-*-*-*-*-koi8-*';	//  

  // 
  FileToPrint	: String = 'lp.prn';	//  / 
  BorderToPrintX= 5.00;			//     ()
  BorderToPrintY= 5.00;

type
{$PACKRECORDS 1}
  TOnceDet	= Record
    Pins	: Array[0..MaxPinD] of word;
    rem		: String[42];
  end;
  TDets		= Array[0..MaxDet] of TOnceDet;

  TOnceLine	= Record
    p1, p2	: Word;
    p		: Byte; // ln*
  end;
  TLines	= Array[0..MaxLines] of TOnceLine;

  TOncePin	= Record
    x, y	: Single;
    p		: Byte; // pn*
  end;
  TPins		= Array[0..MaxPin] of TOncePin;
{$PACKRECORDS Default}

  TPinsState	= Array[0..MaxPin] of Byte; // d0 - selected

var
  TopX, TopY, CurXg, CurYg, CurX, CurY	: Single;
  FileName, FileNameQ			: String;

  WndMain, WndCtrl, WndStat, WndDets	: TWindow;
  ColMain, ColCtrl, ColStat, ColDets	: TColors;

  NearPin, NumDet, LastNoteCur,
  DetListLineHeight			: LongInt;

  fLines	: File of TOnceLine;
  fDets		: File of TOnceDet;
  fPins		: File of TOncePin;
  Dets		: TDets;
  Lines		: TLines;
  Pins		: TPins;
  PinsState	: TPinsState;


procedure note(const s: String);
begin
  LastNote := s; LastNoteCur := GetDataTimeSec;
end;

procedure DelDet;
var n: LongInt;
begin n := SelectDet; repeat Dets[n] := Dets[n+1]; inc(n) until Dets[n].Pins[0] = NoElement end;

procedure DelLine(n: LongInt);
begin repeat Lines[n] := Lines[n+1]; inc(n) until Lines[n].p = lnNo end;

procedure DelLine(const n1, n2: LongInt);
var i: LongInt;
begin
  i := 0;
  while Lines[i].p <> lnNo do with Lines[i] do begin
    if ((p1 = n2) and (p2 = n1)) or
       ((p2 = n2) and (p1 = n1)) then DelLine(i);
    inc(i);
  end;
end;

procedure DelPin;
var pass: Byte; i, j, n: LongInt;
begin
  n := NearPin;
  //     
  for pass := 0 to 1 do begin
    i := 0;
    while Dets[i].Pins[0] <> NoElement do begin
      j := 0;
      while Dets[i].Pins[j] <> NoElement do begin
        case pass of
	  0: if Dets[i].Pins[j] = n then begin Note('  ,  '); exit end;
	  1: if Dets[i].Pins[j] > n then dec(Dets[i].Pins[j]);
	end;
	inc(j);
      end;
      inc(i);
    end;
  end;

  //     
  i:=0;
  while Lines[i].p <> lnNo do
  if (Lines[i].p1 = n) or (Lines[i].p2 = n) then
    DelLine(i)
  else begin
    if Lines[i].p1 > n then dec(Lines[i].p1);
    if Lines[i].p2 > n then dec(Lines[i].p2);
    inc(i);
  end;

  repeat Pins[n] := Pins[n+1]; PinsState[n] := PinsState[n+1]; inc(n) until Pins[n].p = pnNo;
end;

procedure AddChgLine;
var i: LongInt;
begin
  i := 0;
  while Lines[i].p <> lnNo do begin
    if ((Lines[i].p1 = SelectPin) and (Lines[i].p2 = NearPin)) or
       ((Lines[i].p2 = SelectPin) and (Lines[i].p1 = NearPin)) then begin
      case Lines[i].p of
	lnSideF: Lines[i].p := lnSideS;
	lnSideS: Lines[i].p := lnIsol;
	lnIsol : Lines[i].p := lnSideF;
      end;
      exit;
    end;
    inc(i);
  end;
  With Lines[i] do begin
    p1 := SelectPin; p2 := NearPin;
    if (Pins[SelectPin].p = pnSideS) or (Pins[NearPin].p = pnSideS) then p := lnSideS else p := lnSideF;
  end;
  Lines[i+1].p := lnNo;
  SelectPin := NearPin;
end;

procedure AddPin;
var i: LongInt;
begin
  i := 0; while Pins[i].p <> pnNo do inc(i);
  if VisualF or VisualS then With Pins[i] do begin
    x := CurXg; y := CurYg; p := Pins[SelectPin].p;
    if p = pnNo then p := pnBoth;
    if not VisualF and (p = pnSideF) then p := pnSideS;
    if not VisualF and (p = pnFillF) then p := pnFillS;
    if not VisualS and (p = pnSideS) then p := pnSideF;
    if not VisualS and (p = pnFillS) then p := pnFillF;
    PinsState[i] := 0; Pins[i+1].p := pnNo;
  end;
end;

procedure AddDet;
var i, n, p: LongInt;
begin
  n := 0; while Dets[n].Pins[0] <> NoElement do inc(n);
  p := 0; i := 0;
  while Pins[i].p <> pnNo do begin
    if PinsState[i] and 1 <> 0 then begin
      Dets[n].Pins[p] := i;
      inc(p);
    end;
    inc(i);
  end;
  Dets[n].Pins[p] := NoElement; Dets[n].rem := ''; Dets[n+1].Pins[0] := NoElement;
end;

function mm2pxX(const x: Single): LongInt;
begin mm2pxX := round( (x-TopX) * PixPerMMX ) end;

function mm2pxY(const y: Single): LongInt;
begin mm2pxY := round( (y-TopY) * PixPerMMY ) end;

procedure MaxMinSearch(var x1, y1, x2, y2: Single; const AllPins: Boolean);
var i: LongInt;
begin
  i := 0; x1 := 1e10; x2 := -1e10; y1 := 1e10; y2 := -1e10;
  while Pins[i].p <> pnNo do begin
    if AllPins or (PinsState[i] and 1 <> 0) then begin
      if Pins[i].x > x2 then x2 := Pins[i].x;
      if Pins[i].x < x1 then x1 := Pins[i].x;
      if Pins[i].y > y2 then y2 := Pins[i].y;
      if Pins[i].y < y1 then y1 := Pins[i].y;
    end;
    inc(i);
  end;
end;

procedure MaxMinSearchDet(const n: LongInt; var minX, minY, maxX, maxY: Single);
var j: LongInt;
begin
  minX := 1e10; maxX := -1e10; minY := 1e10; maxY := -1e10;
  j := 0;
  while Dets[n].Pins[j] <> NoElement do With Pins[Dets[n].Pins[j]] do begin
    if x > maxX then maxX := x;
    if x < minX then minX := x;
    if y > maxY then maxY := y;
    if y < minY then minY := y;
    inc(j);
  end;
end;

procedure MaxStepRound(var v: Single);
begin if GridEnable then v := Int(v / MaxStepGrid) * MaxStepGrid end;


function CircutSearch(const basepin: LongInt; var area: array of TXPoint; var areacnt: LongInt): Boolean;
var curpin, firstpin, prevline, i: LongInt; linenotfound, findfirst: Boolean;

  function NearPin: LongInt;
  var r, min: Single; i: LongInt; pintype: Byte;
  begin
    if Pins[basepin].p = pnFillF then pintype := pnSideF else pintype := pnSideS;
    NearPin := NoElement; min := 1e20; i := 0;
    while Pins[i].p <> pnNo do begin
      if (i <> basepin) and (Pins[i].p = pintype) then begin
        r := sqrt(sqr(Pins[i].x - Pins[basepin].x) + sqr(Pins[i].y - Pins[basepin].y));
        if r < min then begin min := r; NearPin := i end;
      end;
      inc(i);
    end;
  end;

  procedure add(const n: LongInt);
  begin
    if i <> prevline then begin
      curpin := n;
      area[areacnt].x := mm2pxX(Pins[curpin].x);
      area[areacnt].y := mm2pxY(Pins[curpin].y);
      inc(areacnt);
      linenotfound := False;
      prevline := i;
      if n = firstpin then findfirst := True;
    end;
  end;  

begin
  CircutSearch := False;
  firstpin := NearPin;
  if firstpin = NoElement then note('   ') else begin
    areacnt := 0;
    add(firstpin);
    prevline := NoElement;
    findfirst := False;
    repeat
      i := 0; linenotfound := True;
      while (Lines[i].p <> lnNo) and linenotfound do with Lines[i] do begin
	if p1 = curpin then add(p2);
	if p2 = curpin then add(p1);
	inc(i);
      end;
    until linenotfound or findfirst;
    if linenotfound then note('   ');
    CircutSearch := findfirst;
  end;
end;

procedure SwapIfMax(var a, b: LongInt);
var t: LongInt;
begin if a > b then begin t:=b; b:=a; a:=t end end;

procedure GroupByDet;
var i: LongInt;
begin
  i := 0;
  while Pins[i].p <> pnNo do begin PinsState[i] := PinsState[i] and $FE; inc(i) end;
  i := 0;
  with Dets[SelectDet] do while Pins[i] <> NoElement do begin
    PinsState[Pins[i]] := PinsState[Pins[i]] or $01;
    inc(i);
  end;
end;

procedure DrawPlan(const Wnd: TWindow; var GC: TGC; const Col: TColors; var dt);
var pmTile: TPixMap;

  //  ,   
  procedure LineMM(const x1, y1, x2, y2:Single);
  begin XDrawLine(prDisplay, Wnd, GC, mm2pxX(x1), mm2pxY(y1), mm2pxX(x2), mm2pxY(y2)) end;

  //  
  procedure DrawGrid;
  var x1, y1, x2, y2, c: Single;
  begin
    MaxMinSearch(x1, y1, x2, y2, True);
    if x1 < x2 then begin
      XSetForeGround(prDisplay, GC, Col[ColorG]);
      MaxStepRound(x1); MaxStepRound(y1);

      c := x1;
      repeat LineMM(c, y1, c, y2); c := c + StepGrid until c > x2;

      c := y1;
      repeat LineMM(x1, c, x2, c); c := c + StepGrid until c > y2;
    end;
  end;

  //   
  procedure DrawDets;
  var minX, maxX, minY, maxY: Single; x, y, xl, yl, i: LongInt;
  begin
    i := 0;
    XSetForeGround(prDisplay, GC, Col[ColorDS]);
//	FillSolid, FillTiled, FillStippled or FillOpaqueStippled
    while Dets[i].Pins[0] <> NoElement do begin
      XSetFillStyle(prDisplay, GC, FillTiled);
      XSetLineAttributes(prDisplay, GC, wdWayN, LineDoubleDash, CapNotLast, JoinMiter);
      MaxMinSearchDet(i, minX, minY, maxX, maxY);
      x := mm2pxX(minX-dmRamDet); xl := mm2pxX(maxX+dmRamDet) - x;
      y := mm2pxY(minY-dmRamDet); yl := mm2pxY(maxY+dmRamDet) - y;
      if DetFill and not PrintMode then
        XFillRectangle(prDisplay, Wnd, GC, x, y, xl+1, yl+1)
      else
        XDrawRectangle(prDisplay, Wnd, GC, x, y, xl, yl);
      if i = SelectDet then begin
        XSetFillStyle(prDisplay, GC, FillSolid);
        XSetLineAttributes(prDisplay, GC, wdWayN, LineSolid, CapNotLast, JoinMiter);
        XDrawRectangle(prDisplay, Wnd, GC, x, y, xl, yl);
      end;
      inc(i);
    end;
    XSetFillStyle(prDisplay, GC, FillSolid);
  end;

  //   
  procedure DrawWay(const i: LongInt; const wd: Cardinal; const s, c: LongInt);
  begin
    XSetForeGround(prDisplay, GC, Col[c]);
//      LineSolid, LineOnOffDash, or LineDoubleDash.
//      CapNotLast, CapButt, CapRound or CapProjecting.
//	JoinMiter, JoinRound, JoinBevel
    XSetLineAttributes(prDisplay, GC, wd, s, CapNotLast, JoinMiter);
    with Lines[i] do LineMM(Pins[p1].x, Pins[p1].y, Pins[p2].x, Pins[p2].y);
  end;

  //   
  procedure DrawWays;
  var i: LongInt;
  begin
    i := 0;
    while Lines[i].p <> lnNo do with Lines[i] do begin
      if ( (Pins[p1].p = pnSideF) and (Pins[p2].p = pnSideS)) or
         ( (Pins[p1].p = pnSideS) and (Pins[p2].p = pnSideF)) or
         ( ((Pins[p1].p = pnSideS) or (Pins[p2].p = pnSideS)) and (p = lnSideF) ) or
         ( ((Pins[p1].p = pnSideF) or (Pins[p2].p = pnSideF)) and (p = lnSideS) ) then
	DrawWay(i, wdWayP, LineOnOffDash, ColorEr)
      else
        case p of
          lnSideF: if VisualF then if PrintMode then DrawWay(i, wdWayP, LineSolid, ColorF) else DrawWay(i, wdWayF, LineSolid,     ColorF);
          lnSideS: if VisualS then if PrintMode then DrawWay(i, wdWayP, LineSolid, ColorS) else DrawWay(i, wdWayS, LineOnOffDash, ColorS);
          lnIsol : if PrintMode then else DrawWay(i, wdWayF, LineSolid, ColorU);
        end;
    inc(i);
    end;
    XSetLineAttributes(prDisplay, GC, wdWayN, LineSolid, CapNotLast, JoinMiter);
  end;

  //   ,     
  procedure RestLine(const PinR: LongInt; const Cant: Single);
  var i: LongInt;

    procedure SLine(const x1, y1, x2, y2, r1, f1: LongInt);
    var r, f, a1, a2: Extended;
    begin
      a1 := y2 - y1; a2 := x2 - x1;
      r := sqrt(sqr(a1) + sqr(a2)); f := r;
      if r <> 0 then begin
        r := r1 / r;
        f := f1 / f;
        XDrawLine(prDisplay, Wnd, GC, round(x1 + (x2-x1)*f), round(y1 + (y2-y1)*f), round(x1 + (x2-x1)*r), round(y1 + (y2-y1)*r));
      end;
    end;

    procedure rl(const PinD: LongInt);
    var x1, y1, x2, y2: Single;
    begin
      x1 := Pins[pinR].x; y1 := Pins[pinR].y;
      x2 := Pins[pinD].x; y2 := Pins[pinD].y;
      SLine(mm2pxX(x1), mm2pxY(y1), mm2pxX(x2), mm2pxY(y2), round(Cant*PixPerMMX), round(dmPinH*PixPerMMX));
    end;

  begin
    XSetForeGround(prDisplay, GC, Col[ColorH]);
    XSetLineAttributes(prDisplay, GC, wdWayP, LineSolid, CapNotLast, JoinMiter);
    i := 0;
    while Lines[i].p <> lnNo do with Lines[i] do begin
      if ((p = lnSideF) and VisualF) or ((p = lnSideS) and VisualS) then begin
        if p1=PinR then rl(p2);
        if p2=PinR then rl(p1);
      end;
      inc(i);
    end;
    XSetLineAttributes(prDisplay, GC, wdWayN, LineSolid, CapNotLast, JoinMiter);
  end;

  // 
  procedure Circ(const x, y, r: Single; const c: LongInt);
  begin
    XSetForeGround(prDisplay, GC, Col[c]);
    XFillArc(prDisplay, Wnd, GC, mm2pxX(x-r), mm2pxY(y-r), round(r*PixPerMMX) * 2, round(r*PixPerMMY) * 2, 0*64, 360*64);
  end;

  //      r, ,     Cant,  dmPinH   
  procedure CircleMM(const x, y, r, Cant: Single; const Fill: Boolean; const i, c: LongInt);
  
  begin
    if not Fill and PrintMode then Circ(x, y, Cant, 0);
    Circ(x, y, r, c);
    if Fill then else begin Circ(x, y, dmPinH, 0); if PrintMode then RestLine(i, Cant + dmPinA); end;
  end;

  //      2s
  procedure BarMM(const x, y, s: Single);
  var a, b: LongInt;
  begin
    XSetForeGround(prDisplay, GC, Col[ColorB]);
//    SetFillStyle(SolidFill, GetColor);
    a := mm2pxX(x-s); b := mm2pxY(y-s);
    XFillRectangle(prDisplay, Wnd, GC, a, b, mm2pxX(x+s) - a, mm2pxY(y+s) - b);
    Circ(x, y, dmPinH, 0);
  end;

  //  
  procedure FloodPin(const n: LongInt; const c: Byte);

    {
    procedure FloodFill(const x, y: LongInt);
    var i: PXImage;
    begin
      i := XGetImage(prDisplay, Wnd, 0, 0, ???);
      if i.func.GetPixel(x, y) = 0 then begin
        i.func.PutPixel(x, y);
        FloodFill(x+1, y);
        FloodFill(x-1, y);
        FloodFill(x, y+1);
        FloodFill(x, y-1);
      end;
    end;
    }
    procedure FloodFill(const n, style: LongInt);
    var area: Array[0..100] of TXPoint; np: LongInt;
    begin
      if CircutSearch(n, area, np) then begin
        XSetFillStyle(prDisplay, GC, style);
//	XSetFillMode(prDisplay, GC, EvenOddRule or WindingRule
        XFillPolygon(prDisplay, Wnd, GC, @area, np,  Complex{, Convex, or Nonconvex},  CoordModeOrigin{ or CoordModePrevious});
        XSetFillStyle(prDisplay, GC, FillSolid);
      end;
    end;

  begin
    XSetForeGround(prDisplay, GC, Col[ColorFl]);
    if PrintMode then FloodFill(n, FillSolid)
    else begin
      if DetFill then FloodFill(n, FillTiled);
      Circ(Pins[n].x, Pins[n].y, dmFill, c);
    end;
  end;

  //  
  procedure DrawPins;
  var i: LongInt;
  begin
    i := 0;
    while Pins[i].p <> pnNo do with Pins[i] do begin
      if PrintMode then else begin
        if i = SelectPin then begin
	  XSetForeGround(prDisplay, GC, Col[ColorS1]);
          LineMM(x-dmSel, y-dmSel, x+dmSel, y+dmSel); LineMM(x+dmSel, y-dmSel, x-dmSel, y+dmSel);
	end else if PinsState[i] and 1 <> 0 then begin
	  XSetForeGround(prDisplay, GC, Col[ColorSG]);
          LineMM(x-dmSel, y-dmSel, x+dmSel, y+dmSel); LineMM(x+dmSel, y-dmSel, x-dmSel, y+dmSel);
	end;
      end;
      case p of
        pnSideF : if VisualF then CircleMM(x, y, dmPinS, dmPinR, True, 0, ColorF);
        pnSideS : if VisualS then CircleMM(x, y, dmPinS, dmPinR, True, 0, ColorS);
        pnBoth  : CircleMM(x, y, dmPinB, dmPinR,  False, i, ColorB);
        pnBoth1 : BarMM(x, y, dmPinF);
        pnBothB : CircleMM(x, y, dmPinBk,dmPinRk, False, i, ColorB);
        pnBothB1: BarMM(x, y, dmPinFk);
        pnFillF : if VisualF then FloodPin(i, ColorF);
        pnFillS : if VisualS then FloodPin(i, ColorS);
      end;
      inc(i);
    end;
  end;

  //    PixMap 
  procedure CreateTile;
  begin
    pmTile := XCreatePixMap(prDisplay, Wnd, 2, 2, ColorDepth);
    XSetForeGround(prDisplay, GC, Col[ColorD]);
    XDrawPoint(prDisplay, pmTile, GC, 0, 0);
    XDrawPoint(prDisplay, pmTile, GC, 1, 1);
    XSetForeGround(prDisplay, GC, Col[0]);
    XDrawPoint(prDisplay, pmTile, GC, 1, 0);
    XDrawPoint(prDisplay, pmTile, GC, 0, 1);    
    XSetTile(prDisplay, GC, pmTile);
  end;

  procedure DestroyTile;
  begin
    XFreePixMap(prDisplay, pmTile);
  end;

begin
//  if TopX < 0 then TopX := 0;
//  if TopY < 0 then TopY := 0;
  CreateTile;
  if DetDrawOnly then DrawDets else begin
    if ClearEnable then XClearWindow(prDisplay, Wnd);
    if PrintMode then else begin
      if GridEnable then DrawGrid;
      DrawDets;
    end;
    DrawWays; DrawPins;
  end;
  DestroyTile;
end;

procedure DrawDetsList(const Wnd: TWindow; var GC: TGC; const Col: TColors; var dt);
var i: LongInt;
begin
  if TopDet < 0 then TopDet := 0;
  if TopDet > NumDet then TopDet := NumDet;
  if DetDrawOnly then else XClearWindow(prDisplay, Wnd);
  AlfSetFont(GC, fontDets);
  DetListLineHeight := AlfHeight('-') + 2;
  i := TopDet;
  while Dets[i].Pins[0] <> NoElement do begin
    if i = SelectDet then XSetForeGround(prDisplay, GC, Col[12]) else XSetForeGround(prDisplay, GC, Col[15]);
    AlfOutTextXY(Wnd, GC, 2, DetListLineHeight * (i - TopDet) + 2, ValToStrG(i + 1, 4) + '. ' + Dets[i].rem);
    XSetForeGround(prDisplay, GC, Col[ 8]);
    XDrawLine(prDisplay, Wnd, GC, 0, DetListLineHeight * (i - TopDet + 1), 200, DetListLineHeight * (i - TopDet + 1));
    inc(i);
  end;
  NumDet := i;
end;

procedure Mirror(const AllPins: Boolean);
var x1, y1, x2, y2, os: Single; i: LongInt;
begin
  MaxMinSearch(x1, y1, x2, y2, AllPins);
  if x1 < x2 then begin
    i := 0; os := ((x2-x1) / 2 + x1) * 2;
    while Pins[i].p <> pnNo do begin
      if AllPins or (PinsState[i] and 1 <> 0) then Pins[i].x := os - Pins[i].x;
      inc(i);
    end;
  end;
end;

procedure Rotate(const AllPins: Boolean);
var x1, y1, x2, y2, x, y: Single; i: LongInt;
begin
  MaxMinSearch(x1, y1, x2, y2, AllPins);
  if x1 < x2 then begin
    i := 0;
    while Pins[i].p <> pnNo do begin
      if AllPins or (PinsState[i] and 1 <> 0) then begin
	x := Pins[i].y - y1;
	y := x2 - Pins[i].x;
	Pins[i].x := x1 + x;
	Pins[i].y := y1 + y;
      end;
      inc(i);
    end;
  end;
end;

procedure Load;
var fDetO: File; i, err: LongInt;
begin
  {$I-}
  Assign(fPins, FileName + '.pin'); reset(fPins); i := 0;
  if IOResult <> 0 then begin
    Dets[0].Pins[0] := NoElement; Lines[0].p := lnNo; Pins[0].p := pnNo;
    exit;
  end;
  {$I+}
  TopX := 1e13; TopY := 1e13;
  repeat
    read(fPins, Pins[i]);
    if Pins[i].p <> pnNo then begin
      if TopX > Pins[i].x then TopX := Pins[i].x;
      if TopY > Pins[i].y then TopY := Pins[i].y;
    end;
    inc(i);
  until Pins[i-1].p = pnNo;
  if TopX = 1e13 then TopX := 0; if TopY = 1e13 then TopY := 0;
  MaxStepRound(TopX); MaxStepRound(TopY);
  close(fPins);

  Assign(fLines, FileName+'.lin'); reset(fLines); i := 0;
  repeat read(fLines, Lines[i]); inc(i) until Lines[i-1].p = lnNo;
  close(fLines);

  {$I-}
  Assign(fDets,FileName+'.det'); reset(fDets); i := 0;
  repeat read(fDets, Dets[i]); inc(i); err := IOResult until (Dets[i-1].Pins[0] = NoElement) or (err<>0);
  close(fDets);
  if err<>0 then begin
  {$I+}
    Note('  .det.    ...');
    assign(fDetO,FileName+'.det'); reset(fDetO,1); i := 0;
    repeat
      With Dets[i] do begin
        BlockRead(fDetO, Pins, 2 * 21);
        BlockRead(fDetO, rem, SizeOf(rem));
      end;
      inc(i);
    until Dets[i-1].Pins[0] = NoElement;
  end;
  i := 0; while Dets[i].Pins[0] <> NoElement do with dets[i] do begin rem := a2k_encode(rem); inc(i) end;
end;

procedure Save;
var i: LongInt; d: TOnceDet;
begin
  Assign(fPins, FileName+'.pin'); ReWrite(fPins); i := 0;
  repeat Write(fPins, Pins[i]); inc(i) until Pins[i-1].p = pnNo;
  close(fPins);

  Assign(fLines, FileName+'.lin'); ReWrite(fLines); i := 0;
  repeat Write(fLines, Lines[i]); inc(i) until Lines[i-1].p = lnNo;
  close(fLines);

  Assign(fDets, FileName+'.det'); ReWrite(fDets); i := 0;
  repeat d := Dets[i]; d.rem := k2a_encode(d.rem); Write(fDets, d); inc(i) until Dets[i-1].Pins[0] = NoElement;
  close(fDets);

  Note('Saved...');
end;

procedure InterAction;
const
  //   
  ButX		: LongInt = 863;
  ButY		: LongInt = 23;
  ButOfsX	= 5;
  ButOfsY	= 9;
  ButStpY	= 30;
  ButLenX	= 70;
  ButLenY	= ButStpY - ButOfsY;

  //  
  MainX		: LongInt = 0;
  MainY		: LongInt = 0;
  MainScr	= 20;
  MainDiv	= 7;
  MainChX	: LongInt = 900;
  MainChY	: LongInt = 700;

  //   
  DetX		: LongInt = 761;
  DetY		: LongInt = 0;
  DetScr	= 15;
  DetDiv	= 7;
  DetWid	: LongInt = 080;
  DetHig	: LongInt = 080;

  //  
  StatX		: LongInt = 703;
  StatY		: LongInt = 605;

var
  msExit, ms250, ms125, msSave, msPrint, msMir, msRot, msScale, msScaSc, msDet, msPlan,
  msPlUp, msPlDn, msPlRg, msPlLf, msDetUp, msDetDn, msDetLst,
  msSideF, msSideS	: RngMouseArea;
  Event: TXEvent;
  CurrentWindow: TWindow;

  //          WndMain
  procedure SetWndMain;
  begin
    SetMouseArea(msPlan, msActive, MainScr + MainDiv*2,           MainScr + MainDiv*2, MainChX, MainChY,  0, 0,  '', XC_top_left_arrow);
    SetMouseArea(msPlUp, msActive, MainScr + MainDiv*2,			      MainDiv, MainChX, MainScr, 12, 8, '^', XC_sb_down_arrow);
    SetMouseArea(msPlDn, msActive, MainScr + MainDiv*2, MainDiv*3 + MainScr + MainChY, MainChX, MainScr, 12, 8, 'v', XC_sb_up_arrow);
    SetMouseArea(msPlRg, msActive,                       MainDiv, MainDiv*2 + MainScr, MainScr, MainChY, 12, 8, '<', XC_sb_right_arrow);
    SetMouseArea(msPlLf, msActive, MainScr + MainDiv*3 + MainChX, MainDiv*2 + MainScr, MainScr, MainChY, 12, 8, '>', XC_sb_left_arrow);
  end;

  //          WndDets
  procedure SetWndDets;
  begin
    SetMouseArea(msDetLst, msActive, DetDiv,          DetDiv*2 + DetScr, DetWid, DetHig,  0, 0,  '',  XC_bogosity);
    SetMouseArea(msDetUp,  msActive, DetDiv,                     DetDiv, DetWid, DetScr, 12, 8,  '^', XC_sb_down_arrow);
    SetMouseArea(msDetDn,  msActive, DetDiv, DetDiv*3 + DetScr + DetHig, DetWid, DetScr, 12, 8,  'v', XC_sb_up_arrow);
  end; 

  //      
  Procedure SearchNearPin;
  var i: LongInt;
  begin
    i := 0; NearPin := NoElement;
    if MouseInArea(msPlan){ and (VisualF or VisualS)} then
      while Pins[i].p <> pnNo do with Pins[i] do begin
        if (sqr(x - CurX) + sqr(y - CurY) < sqr(PrecesSearch)) and
           (not (p in [pnSideF, pnFillF]) or VisualF) and
	   (not (p in [pnSideS, pnFillS]) or VisualS) then begin NearPin := i; break end;
        inc(i);
      end;
  end;

  //        ()
  procedure px2mmMouse;
  begin
    if MouseInArea(msPlan) then begin
      CurX := MouseX / PixPerMMX + TopX;
      CurY := MouseY / PixPerMMY + TopY;
      if GridEnable then begin
        CurXg := round(CurX / StepGrid) * StepGrid;
	CurYg := round(CurY / StepGrid) * StepGrid;
      end else begin
        CurXg := CurX;
	CurYg := CurY;
      end;
    end else CurXg := UnDefine;
  end;

  //    
  function Region(var ax, ay, bx, by: LongInt): Boolean;
  var GC: TGC; Values: TXGCValues; Wnd: TWindow; x, y: LongInt;
  begin
    SetMouseArea(msPlan, msActive, MainScr + MainDiv*2, MainScr + MainDiv*2, MainChX, MainChY, 0, 0, '', XC_sizing);
    Wnd := GetMouseWnd(msPlan);
    x := MouseX; y := MouseY;
    With Values do begin Xfunction := GXxor; foreground := ColMain[2]; end;
    GC := XCreateGC(prDisplay, Wnd, GCFunction or GCForeground, @Values);
    repeat
      ax := x; bx := MouseX; SwapIfMax(ax, bx);
      ay := y; by := MouseY; SwapIfMax(ay, by);
      if XPending(prDisplay) = 0 then begin
        XDrawRectangle(prDisplay, Wnd, GC, ax, ay, bx-ax, by-ay); XFlush(prDisplay);
        Delay(50000);
        XDrawRectangle(prDisplay, Wnd, GC, ax, ay, bx-ax, by-ay); XFlush(prDisplay);
        Delay(50000);
      end;
      FlTmWithPause(Event, False);
    until (KeyInResult = XK_Escape) or not TestButton(MouseRmsk);
    Region := KeyInResult <> XK_Escape;
    XFreeGC(prDisplay, GC);
    SetWndMain;
  end;

  //    ,  Select     
  procedure SelGroup;
  var ax, ay, bx, by, i: LongInt;
  begin
    if MouseInArea(msPlan) then if Region(ax, ay, bx, by) then begin
      i := 0;
      while Pins[i].p <> pnNo do with Pins[i] do begin
        PinsState[i] := (PinsState[i] and $FE) or ord(
	  (mm2pxX(x) > ax) and (mm2pxX(x) < bx) and
	  (mm2pxY(y) > ay) and (mm2pxY(y) < by)
        );
        inc(i);
      end;
    end;
  end;

  //    
  procedure DrawStat;
  var x1, x2, y1, y2: Single; GC: TGC; i: LongInt;
  begin
    if LastNoteCur + LastNoteMax < GetDataTimeSec then LastNote := '                            ';
    GC := XCreateGC(prDisplay, WndStat, 0, Nil);
    XSetBackGround(prDisplay, GC, XBlackPixel(prDisplay, nScreenNum));
    XSetForeGround(prDisplay, GC, XWhitePixel(prDisplay, nScreenNum));
    AlfSetFont(GC, fontNote);
    AlfOutTextXY(WndStat, GC, 5, 5, LastNote);

    {i := 0; While Dets[i].Pins[0] <> NoElement do inc(i);}
    jkl(WndStat, GC, ': ' + ValToStrG(NumDet, 4) + ' / ' + ValToStrG(MaxDet, 4) + ' ');

    i := 0; While Lines[i].p <> lnNo do inc(i);
    jkl(WndStat, GC, '  : ' + ValToStrG(i, 4) + ' / ' + ValToStrG(MaxLines, 4) + ' ');

    i := 0; While Pins[i].p <> pnNo do inc(i);
    jkl(WndStat, GC, '  : ' + ValToStrG(i, 4) + ' / ' + ValToStrG(MaxPin, 4) + ' ');

    MaxMinSearch(x1, y1, x2, y2, True);
    jkl(WndStat, GC, ' : ' + ValToStrS(x2-x1, 5) + ' x ' + ValToStrS(y2-y1, 5) + '  ');
    if MouseInArea(msPlan) then begin
      jkl(WndStat, GC, ' : ' + ValToStrS(CurX, 5) + ',  ' + ValToStrS(CurY, 5) + '  ');
      if NearPin <> NoElement then begin
        with Pins[NearPin] do
        jkl(WndStat, GC, '    : ' + ValToStrS(x, 5) + ',  ' + ValToStrS(y, 5) + '  ');
      end else
        jkl(WndStat, GC, '                         ');
    end else begin
      jkl(WndStat, GC, '                         ');
    end;
    XFreeGC(prDisplay, GC);
  end;

  //   drag&drop'    
  procedure MovePin;
  begin
    SetMouseArea(msPlan, msActive, MainScr + MainDiv*2, MainScr + MainDiv*2, MainChX, MainChY, 0, 0, '', XC_hand2);
    repeat
      FlTmWithPause(Event, True);
      px2mmMouse;
      DrawStat;
    until (KeyInResult = XK_Escape) or not TestButton(MouseLmsk);
    if KeyInResult <> XK_Escape then begin
      Pins[NearPin].x := CurXg; Pins[NearPin].y := CurYg; SelectPin := NearPin;
    end;
    SetWndMain;
  end;

  //    drag&drop'
  procedure MoveGroup;
  var sx, sy: Single; i: LongInt;
  begin
    SetMouseArea(msPlan, msActive, MainScr + MainDiv*2, MainScr + MainDiv*2, MainChX, MainChY, 0, 0, '', XC_fleur{XC_rtl_logo});
    sx := CurXg; sy := CurYg;
    repeat
      FlTmWithPause(Event, True);
      px2mmMouse;
      DrawStat;
      if ((sx <> CurXg) or (sy <> CurYg)) and (CurXg <> UnDefine) then begin
        i := 0;
        while Pins[i].p <> pnNo do begin
  	  if PinsState[i] and 1 <> 0 then begin
	    Pins[i].x := round((Pins[i].x + CurXg - sx) / StepGrid) * StepGrid;
	    Pins[i].y := round((Pins[i].y + CurYg - sy) / StepGrid) * StepGrid;
	  end;
	  inc(i);
        end;
	DrawButton(msPlan);
        sx := CurXg; sy := CurYg;
      end;
    until not (TestMKey(skRShift) or TestMKey(skLShift));
    SetWndMain;
  end;

  //    ,      
  procedure ScaleToFit(const m: Byte);
  var x1, x2, y1, y2: Single;
  begin
    MaxMinSearch(x1, y1, x2, y2, True);
    TopX := x1; TopY := y1;
    if x1 < x2 then begin
      case m of
      1: begin PixPerMMX := MainChX / (x2 - x1); PixPerMMY := PixPerMMX end;
      2: begin PixPerMMY := MainChY / (y2 - y1); PixPerMMX := PixPerMMY end;
      3: begin PixPerMMX := MainChX / (x2 - x1); PixPerMMY := MainChY / (y2 - y1) end;
      end;
    end;
  end;

  //    SelectDet
  procedure ToCenterDet;
  var minX, minY, maxX, maxY: Single;
  begin
    MaxMinSearchDet(SelectDet, minX, minY, maxX, maxY); 
    TopX := minX - (MainChX div 2) / PixPerMMX + (maxX - minX) / 2;
    TopY := minY - (MainChY div 2) / PixPerMMY + (maxY - minY) / 2;
  end;

  //    DetLst
  procedure InDetLst;
  begin
    if MouseInArea(msDetLst) then begin
      if Event.EventType = MotionNotify then SelectDet := (MouseY div DetListLineHeight) + TopDet;
      DetDrawOnly := True;
      DrawButton(msPlan); DrawButton(msDetLst);
      DetDrawOnly := False;
      if Event.EventType = ButtonPress then begin
        if TestButton(MouseLmsk) then begin ToCenterDet; GroupByDet; DrawButton(msPlan) end;
	if TestButton(MouseRmsk) then if AlfEnterString(Dets[SelectDet].rem, '  : ', MouseXroot, MouseYroot) then else DrawButton(msDetLst);
	if TestButton(MouseMmsk) then DelDet;
      end;
      if Event.EventType = KeyPress then begin
        if SelectDet < 0 then SelectDet := 0;
        if SelectDet > NumDet - 1 then SelectDet := NumDet - 1;
        if TopDet > SelectDet then TopDet := SelectDet;
        if TopDet + DetHig div DetListLineHeight < SelectDet then TopDet := SelectDet - DetHig div DetListLineHeight;
      end;
    end else SelectDet := NoElement;
  end;
  
  //  ,  
  procedure Print;
  const m: Array[0..7] of TdgItem=(
    (st: ' PCL-';		bC: 1; fC: 14;		ms:0; tp: dgRemark),
    (st: '  ';	bC: 0; fC: ColorF;	ms:0; tp: dgBoolean; vl_b: True),
    (st: '  ';	bC: 0; fC: ColorS;	ms:0; tp: dgBoolean; vl_b: False),
    (st: '  ';		bC: 0; fC: 15;		ms:0; tp: dgBoolean; vl_b: True),
    (st: '';				bC: 0; fC: 15;		ms:0; tp: dgDivider),
    (st: ' ';			bC: 0; fC: 15;		ms:0; tp: dgString; vl_s: ''),
    (st: '';			bC: 1; fC: 15;		ms:0; tp: dgOk),
    (st: '';			bC: 4; fC: 15;		ms:0; tp: dgCancel)
  );
  var
    F, S	: Boolean;
    pm		: TPixMap;
    fl		: Text;
    minX, minY,
    maxX, maxY,
    rx, ry,
    tx, ty	: Single;
    GC		: TGC;
    xl, yl	: LongInt;

  procedure CallDraw(const F, S: Boolean);
  begin
    XSetForeGround(prDisplay, GC, XBlackPixel(prDisplay, nScreenNum));
    XSetFillStyle(prDisplay, GC, FillSolid);
    XFillRectangle(prDisplay, pm, GC, 0, 0, xl, yl);
    VisualF := F; VisualS := S;
    DrawPlan(pm, GC, ColMain, pm); PrintWnd(pm, xl, yl, fl);
  end;

  begin
    m[5].vl_s := FileToPrint;
    if Dialog(m) then begin
      FileToPrint := m[5].vl_s;

      F := VisualF; S := VisualS;
      tx := TopX; ty := TopY;
      rx := PixPerMMX; ry := PixPerMMY;
      PixPerMMX := 1 / (25.400 / PrintResX); PixPerMMY := 1 / (25.400 / PrintResY);
      ClearEnable := False;

      MaxMinSearch(minX, minY, maxX, maxY, True);
      if minX < maxX then begin
        minX := minX - BorderToPrintX; maxX := maxX + BorderToPrintX;
        minY := minY - BorderToPrintY; maxY := maxY + BorderToPrintY;
    
        TopX := minX; TopY := minY;
        xl := Round((maxX - minX) * PixPerMMX); yl := Round((maxY - minY) * PixPerMMY);

        pm := XCreatePixMap(prDisplay, WndMain, xl, yl, ColorDepth);
        GC := XCreateGC(prDisplay, pm, 0, Nil);
        assign(fl, FileToPrint); rewrite(fl);

        if m[1].vl_b then begin
          PrintMode := True;
          Mirror(True); CallDraw(True, False); Mirror(True);
          writeln(fl, #10);
          PrintMode := False;
        end;
        if m[2].vl_b then begin
          PrintMode := True;
          CallDraw(False, True);
          writeln(fl, #10);
          PrintMode := False;
        end;
        if m[3].vl_b then begin
          GridEnable := False;
          CallDraw(True, True);
          GridEnable := True;
        end;
        writeln(fl, #12);

        close(fl);
        XFreeGC(prDisplay, GC);
        XFreePixMap(prDisplay, pm);

        VisualF := F; VisualS := S;
        TopX := tx; TopY := ty;
        PixPerMMX := rx; PixPerMMY := ry;
        ClearEnable := True;

        PCLView(FileToPrint);
      end;
    end;
  end;

begin
  IniOpen('Geometry');
  IniGet('Main X', MainX); IniGet('Main Ch X', MainChX);
  IniGet('Main Y', MainY); IniGet('Main Ch Y', MainChY);

  IniGet('Detail X', DetX); IniGet('Detail Width', DetWid);
  IniGet('Detail Y', DetY); IniGet('Detail Height', DetHig);

  IniGet('Button X', ButX); IniGet('Button Y', ButY);

  IniGet('Stat X', StatX); IniGet('Stat Y', StatY);
  IniClose;

  NewRootWindow(MainX, MainY,
    MainChX + MainScr*2 + MainDiv*4, MainChY + MainScr*2 + MainDiv*4,
	             MainScr * 2 + MainDiv * 4 + 10, MainScr * 2 + MainDiv * 4 + 10, ' '      + FileNameQ, ' '      + FileNameQ, WndMain); SetVGAPalette(WndMain, ColMain);
  NewRootWindow(ButX,  ButY, ButLenX + ButOfsX*2,       ButStpY*12 + ButOfsY*2, 10, 10, ' ' + FileNameQ, ' ' + FileNameQ, WndCtrl); SetVGAPalette(WndCtrl, ColCtrl);
  NewRootWindow(StatX, StatY,		  240,  		        130, 10, 10, ' ' + FileNameQ, ' ' + FileNameQ, WndStat); SetVGAPalette(WndStat, ColStat);
  NewRootWindow(DetX, DetY,
    DetWid + DetDiv*2, DetHig + DetDiv*4 + DetScr*2,
				      DetDiv * 2 + 10, DetDiv * 4 + DetScr * 2 + 10, ' '     + FileNameQ, ' '     + FileNameQ, WndDets); SetVGAPalette(WndDets, ColDets);

  SetMouseButton(WndCtrl, msExit,  ButOfsX, ButStpY * 0 + ButOfsY, ButLenX, ButLenY, 15,  4, 'Exit',       XC_pirate);
  SetMouseButton(WndCtrl, msMir,   ButOfsX, ButStpY * 1 + ButOfsY, ButLenX, ButLenY, 15,  9, 'Mirror',     XC_sb_h_double_arrow);
  SetMouseButton(WndCtrl, msRot,   ButOfsX, ButStpY * 2 + ButOfsY, ButLenX, ButLenY, 15,  9, 'Rotate',     XC_ul_angle);
  SetMouseButton(WndCtrl, msPrint, ButOfsX, ButStpY * 3 + ButOfsY, ButLenX, ButLenY, 15,  8, 'Print',      XC_trek);
  SetMouseButton(WndCtrl, msSave,  ButOfsX, ButStpY * 4 + ButOfsY, ButLenX, ButLenY, 15,  2, 'Save',       XC_heart);
  SetMouseButton(WndCtrl, msScale, ButOfsX, ButStpY * 5 + ButOfsY, ButLenX, ButLenY, 15,  3, '',    XC_exchange);
  SetMouseButton(WndCtrl, msScaSc, ButOfsX, ButStpY * 6 + ButOfsY, ButLenX, ButLenY, 15,  3, ' ',    XC_iron_cross);
  SetMouseButton(WndCtrl, msDet,   ButOfsX, ButStpY * 7 + ButOfsY, ButLenX, ButLenY, 15,  3, '',     XC_icon);
  SetMouseButton(WndCtrl, ms250,   ButOfsX, ButStpY * 8 + ButOfsY, ButLenX, ButLenY, 15,  3, ' 2.50', XC_plus);
  SetMouseButton(WndCtrl, ms125,   ButOfsX, ButStpY * 9 + ButOfsY, ButLenX, ButLenY, 15,  3, ' 1.25', XC_tcross);
  SetMouseButton(WndCtrl, msSideF, ButOfsX, ButStpY *10 + ButOfsY, ButLenX, ButLenY,  0, 10, ' 1',  XC_bottom_tee);
  SetMouseButton(WndCtrl, msSideS, ButOfsX, ButStpY *11 + ButOfsY, ButLenX, ButLenY,  0, 11, ' 2',  XC_top_tee);

  NewMouseArea(WndMain, msPlan); SetMouseRoutines(msPlan, @DrawPlan, msPlan, Nil, Nil, Nil);
  NewMouseArea(WndMain, msPlUp);
  NewMouseArea(WndMain, msPlDn);
  NewMouseArea(WndMain, msPlRg);
  NewMouseArea(WndMain, msPlLf);
  SetWndMain;

  NewMouseArea(WndDets, msDetLst); SetMouseRoutines(msDetLst, @DrawDetsList, msDetLst, Nil, Nil, Nil);
  NewMouseArea(WndDets, msDetUp);
  NewMouseArea(WndDets, msDetDn);
  SetWndDets;


repeat
  KeyInResult := 0;
  FlTmWithPause(Event, True);
  px2mmMouse;
  SearchNearPin;

  //     --------------------
  Case Event.EventType of

    Expose: with Event.XExpose do begin
      if Window = WndStat then DrawStat;
    end;

    ConfigureNotify: with Event.XConfigure do begin
      if Window = WndMain then begin
        MainChX := Width - MainDiv * 4 - MainScr * 2; MainChY := Height - MainDiv * 4 - MainScr * 2;
        SetWndMain;
      end;
      if Window = WndDets then begin
        DetWid := Width - DetDiv * 2; DetHig := Height - DetDiv * 4 - DetScr * 2;
        SetWndDets;
      end;
    end;

    KeyPress: if (KeyInResult = XK_Control_L) or (KeyInResult = XK_Control_R) then begin
      XMapWindow(prDisplay, WndCtrl);
      XMapWindow(prDisplay, WndStat);
    end;

    KeyRelease: if (KeyInReleased = XK_Control_L) or (KeyInReleased = XK_Control_R) then begin
      XUnMapWindow(prDisplay, WndCtrl);
      XUnMapWindow(prDisplay, WndStat);
    end;

    FocusIn: CurrentWindow := Event.XFocus.Window;

    DeleteNotify: begin
      if CurrentWindow = WndMain then Break;
      if (CurrentWindow = WndCtrl) or (CurrentWindow = WndStat) or (CurrentWindow = WndDets) then XUnMapWindow(prDisplay, CurrentWindow);
    end;

  //    --------------------------------------
    ButtonPress: begin
      if MouseInArea(msSave) then Save;
      if MouseInArea(msDet) then DetFill := not DetFill;
      if MouseInArea(ms250) then StepGrid := 2.5;
      if MouseInArea(ms125) then StepGrid := 1.25;
      if MouseInArea(msSideF) then VisualF := not VisualF;
      if MouseInArea(msSideS) then VisualS := not VisualS;
    end;

  end;

  //    --------------------------------------
  if TestButton(MouseLmsk) and (Event.EventType = ButtonPress) then begin
    if NearPin <> NoElement then MovePin else if CurXg <> UnDefine then AddPin;

    if MouseInArea(msPrint) then Print;
    if MouseInArea(msPlRg) then TopX := TopX - StepXMove;
    if MouseInArea(msPlLf) then TopX := TopX + StepXMove;
    if MouseInArea(msPlUp) then TopY := TopY - StepYMove;
    if MouseInArea(msPlDn) then TopY := TopY + StepYMove;

    if MouseInArea(msScale) then begin PixPerMMX := PixPerMMX * 2; PixPerMMY := PixPerMMY * 2 end;

    if MouseInArea(msMir) then Mirror(True);
    if MouseInArea(msRot) then Rotate(True);
    if MouseInArea(msScaSc) then ScaleToFit(1);

    if MouseInArea(msDetUp) then Dec(TopDet);
    if MouseInArea(msDetDn) then Inc(TopDet);

    DrawButton(msPlan); DrawButton(msDetLst); Delay(100000);
  end;

  //    -------------------------------------
  if TestButton(MouseRmsk) and (Event.EventType = ButtonPress) then begin
    if MouseInArea(msPrint) then PCLView(FileToPrint);
    if MouseInArea(msPlRg) then TopX := TopX - StepXMove*5;
    if MouseInArea(msPlLf) then TopX := TopX + StepXMove*5;
    if MouseInArea(msPlUp) then TopY := TopY - StepYMove*5;
    if MouseInArea(msPlDn) then TopY := TopY + StepYMove*5;

    if MouseInArea(msScale) then begin PixPerMMX := PixPerMMX / 2; PixPerMMY := PixPerMMY / 2 end;
    if MouseInArea(msMir) then Mirror(False);
    if MouseInArea(msRot) then Rotate(False);
    if MouseInArea(msScaSc) then ScaleToFit(2);

    if MouseInArea(msDetUp) then Dec(TopDet, 10);
    if MouseInArea(msDetDn) then Inc(TopDet, 10);

    if NearPin = NoElement then SelGroup else if SelectPin <> NearPin then AddChgLine;

    DrawButton(msPlan); DrawButton(msDetLst); Delay(100000);
  end;

  //    ------------------------------------
  if TestButton(MouseMmsk) and (Event.EventType = ButtonPress) then begin
    if MouseInArea(msPrint) then AlfEnterString(FileToPrint, ' PCL-: ', MouseXroot, MouseYroot);
    if MouseInArea(msScale) then begin PixPerMMX := 1 / (25.400 / PrintResX); PixPerMMY := 1 / (25.400 / PrintResY); end;
    if MouseInArea(msScaSc) then ScaleToFit(3);
    if NearPin <> NoElement then begin DelPin; DrawButton(msPlan); end;
    DrawButton(msPlan); DrawButton(msDetLst); Delay(100000);
  end;

  //    --------------------------
  if (TestMKey(skRShift) or TestMKey(skLShift)) and MouseInArea(msPlan) then MoveGroup;

  //   --------------------------------------
  case KeyInResult of
  XK_F2		: Save;
  ord('p')	: if CurXg <> UnDefine then if NearPin = NoElement then AddPin else DelPin;
  ord('1')..ord('8'): if NearPin <> NoElement then Pins[NearPin].p := KeyInRes[0] - 48;
  ord(' ')	: if NearPin <> NoElement then SelectPin := NearPin;
  ord('P')	: PrintMode := not PrintMode;
  ord('G')	: GridEnable := not GridEnable;
  ord('d')	: if SelectDet <> NoElement then DelDet else AddDet;
  XK_Delete	: if NearPin <> SelectPin then DelLine(NearPin, SelectPin);
  XK_F5		: XMapWindow(prDisplay, WndCtrl);
  XK_F6		: XMapWindow(prDisplay, WndStat);
  XK_F7		: XMapWindow(prDisplay, WndDets);
  end;

  if MouseInArea(msPlan) then case KeyInResult of
  XK_Left	: if TopX >= StepXMove then TopX := TopX - StepXMove;
  XK_Right	: TopX := TopX + StepXMove;
  XK_Up		: if TopY >= StepYMove then TopY := TopY - StepYMove;
  XK_Down	: TopY := TopY + StepYMove;
  end;

  if MouseInArea(msDetLst) then case KeyInResult of
  XK_Left, XK_Home: SelectDet := 0;
  XK_Right, XK_End: SelectDet := NumDet - 1;
  XK_Up		  : Dec(SelectDet);
  XK_Down	  : Inc(SelectDet);
  XK_Return	  : if AlfEnterString(Dets[SelectDet].rem, '  : ', MouseX, MouseY) then else DrawButton(msDetLst);
  end;
  InDetLst;

  if KeyInResult <> 0 then begin DrawButton(msPlan); DrawButton(msDetLst); end;

  DrawStat;
//  XRestackWindows
until MouseInArea(msExit) and TestButton(MouseMmsk);

  IniOpen('Geometry');
  IniPut('Main Ch X', MainChX);
  IniPut('Main Ch Y', MainChY);

  IniPut('Detail Width', DetWid);
  IniPut('Detail Height', DetHig);
  IniClose;
end;

begin
  WriteLn('PLATS:   16.08.2005');

  IniOpen('Plats');
  if ParamCount < 1 then begin
    if IniGet('PlanFile', FileName) then else begin WriteLn('   .'); Halt end;
  end else begin
    FileName := ParamStr(1);
    IniPut('PlanFile', FileName);
  end;

  IniGet('Font of Notes',	fontNote);
  IniGet('Font of Detail List',	fontDets);

  IniGet('Pixel Per mm X',	PixPerMMX);
  IniGet('Pixel Per mm Y',	PixPerMMY);
  IniGet('Visual First', 	VisualF);
  IniGet('Visual Second',	VisualS);
  IniGet('Fill Detail',		DetFill);
  IniGet('PCL file name',	FileToPrint);
  IniClose;

  Load; FileNameQ := '"' + FileName + '"';

  InterAction;

  IniOpen('Plats');
  IniPut('Pixel Per mm X',	PixPerMMX);
  IniPut('Pixel Per mm Y',	PixPerMMY);
  IniPut('Visual First', 	VisualF);
  IniPut('Visual Second',	VisualS);
  IniPut('Fill Detail',		DetFill);
  IniPut('PCL file name',	FileToPrint);
  IniClose;
end.